<?php
// These are variables used by the xml parse functions, please do not edit
$XMLtag_info['in_event'] = FALSE;	// TRUE/FALSE depending if we are in <EVENT>
$XMLtag_info['in_child'] = FALSE;	// TRUE/FALSE depending if we are in <EVENT> and a 'child' tag
$XMLtag_info['child_tag'] = '';	// The name of the child tag, else empty
$XMLtag_info['save_index'] = 0;	// An auto inceremented value for indexing the data
$XMLsaved_data = '';			// This will become a 2xarray, $XMLsaved_data[<num_index>][<CHILD_TAG>]
?>
<?php
	function startElement($parser, $name, $attrs){
		// This function is used by the xml_parse function in php
		
		// Globalize some vars to get access to them within the function
		global $XMLtag_info, $XMLsaved_data;
		
			// Checks if we already is in a <EVENT> tag, or if we just encounterd a <EVENT>
			// Sets the appropriate values to the vars depending what happend
			if( $XMLtag_info['in_event'] ){
				$XMLtag_info['in_child'] = TRUE;
				$XMLtag_info['child_tag'] = $name;
			}elseif( $name == 'EVENT' ){
				$XMLtag_info['in_event'] = TRUE;
				$XMLtag_info['in_child'] = FALSE;
				$XMLtag_info['child_tag'] = '';
			}
	}

	function characterData($parser, $data){
		// This function is used by the xml_parse function in php
	
		// Globalize some vars to get access to them within the function
		global $XMLtag_info, $XMLsaved_data;
		
			// Evaluates if we should save data between tags
			if( $XMLtag_info['in_event'] ){
				if( $XMLtag_info['in_child'] ){
					$TMPnum_index = intval( $XMLtag_info['save_index'] );
					$TMPname_index = $XMLtag_info['child_tag'];
					
						$XMLsaved_data[$TMPnum_index][$TMPname_index] = $data;
				}
			}
	}

	function endElement($parser, $name){
		// This function is used by the xml_parse function in php

		// Globalize some vars to get access to them within the function
		global $XMLtag_info, $XMLsaved_data;
		
			// Evaluates the end tag, can NOT handle <EVENT> tags as childs
			if( $XMLtag_info['in_event'] && $name == 'EVENT' ){
				$XMLtag_info['in_event'] = FALSE;
				$XMLtag_info['save_index']++;
			}elseif( $XMLtag_info['in_child'] && $XMLtag_info['child_tag'] == $name ){
				$XMLtag_info['in_child'] = FALSE;
				$XMLtag_info['child_tag'] = '';
			}
	}
?>
<?php
	function parse_history_users( $path ){
		// This function:
		// array( array ) parse_history_users( void )
		// Return information of messages ( 'CONTAC','FROM','TIME','DATE','PROTOCOL','ID','TYPE','MESSAGE' )

		// Include XMLparse to access the dictated functions for xml parsing below
		// Also declares the global variables to access options set by the user
		global $XMLtag_info, $XMLsaved_data;

				// Sets the path to the xml file and gets the contents of the file
				$path = $path;
				$data = file_get_contents( $path );

					// Start a parser
					$xml_parser = xml_parser_create();

						// Decalers whitch functions to use for start elements, handeling data
						// and when a end tag is meet
						xml_set_element_handler( $xml_parser, 'startElement', 'endElement' );
						xml_set_character_data_handler( $xml_parser, 'characterData' );

					// Ends the parser
					xml_parse( $xml_parser, $data );

			// Free up memory used by xml parser
			xml_parser_free( $xml_parser );

		return $XMLsaved_data;
	}
?>